﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using System.Diagnostics;

namespace WamGrid_Select_2Events
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            // Prepare viewmodel to be use with the grid
            ViewModel data = new ViewModel();
            data.Elements = new System.Collections.ObjectModel.ObservableCollection<T_Person>();
            data.Elements.Add(new T_Person { ID = 1, FirstName = "Will", LastName = "Smith" });
            data.Elements.Add(new T_Person { ID = 2, FirstName = "Bart", LastName = "Simpson" });
            data.Elements.Add(new T_Person { ID = 3, FirstName = "John", LastName = "Doe" });

            // Select fiest element
            data.OneElement = data.Elements[0];

            InitializeComponent();

            // To have all cels selected in a row
            this.XamGridElements.SelectionSettings.CellClickAction = CellSelectionAction.SelectRow;
            this.XamGridElements.SelectionSettings.CellSelection = SelectionType.None;

            // Give viewmodel to the view
            this.DataContext = data;

        }

        private void btnEditElement_Click(object sender, RoutedEventArgs e)
        {
            Debug.WriteLine("--- Click : Click on edit button");

        }


        // What we would like : only click event raised
        private void btnEditElement_Click_2(object sender, RoutedEventArgs e)
        {
            // some treatments here

            // Get row where button is

            // Select the row now (to have "selection" event raised)
        }


        private void txtTestFocus_IsEnabledChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            // When IsEnabled is set to true, focus is set to the text field
            // Same thing happen when BusyIndicator is used  in LoadData() :
            //          1 - focus is set somewhere inside BusyIndicator (by BusyIndicator itself)
            //          2 - edit button is loosing focus and "click" event is never raised
            if ((bool)e.NewValue)
            {
                this.txtTestFocus.Focus();
            }
           
        }
    }
}
